<template>
  <i-wrapper top>
    <i-stepper :total="auth.onboarding.total" :filled="4" />
    <i-curtain tag="form" @submit="submit()">
      <img src="~assets/images/bubbles-orange.svg" class="bubbles bubbles--custom" />
      <img src="~assets/images/scientist-clock.png" class="scientist-clock" />
      <div class="title px-1 text-center">{{ $t(`Excellent!`) }}</div>
      <div class="normal-text text-center px-1">
        {{ $t(`Do you happen to know at what time?`) }}
      </div>
      <template #bottom>
        <i-input
          ref="birthTimeInput"
          v-model="birthTime"
          :default-value="defaultBirthTime"
          type="time"
          :placeholder="$t(`Type the time of birth`)"
          :flow="['time']" />
        <i-button
          block
          transparent
          style="margin: 3px 0"
          :loading="isLoading === 'skip'"
          :disabled="!!isLoading"
          @click="submit(true)">
          {{ $t(`I DON'T REMEMBER`) }}
        </i-button>
        <i-button submit block :loading="isLoading === 'submit'" :disabled="!!isLoading">{{ $t(`CONTINUE`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',

    data() {
      return {
        birthTime: this.$store.state.auth.onboarding.birthTime
          ? `1970-01-01T${this.$store.state.auth.onboarding.birthTime}`
          : null,
        defaultBirthTime: '1970-01-01T00:00:00',
        isLoading: null,
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    methods: {
      async submit(skip = false) {
        if (this.isLoading) {
          return;
        }

        console.log('SUBMIT');

        if (!skip && !this.birthTime) {
          this.$refs.birthTimeInput.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.birthTimeInput.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = skip ? 'skip' : 'submit';

        try {
          let response = await this.$axios.post(`onboarding/birth_time`, {
            birthTime: skip ? null : this.birthTime.split('T')[1].split('.')[0],
          });

          ga('send', 'event', 'onb_4_birth_time');
          this.$store.commit('MERGE_AUTH', { onboarding: response.data.data, user: response.data.data.user });
          await this.$router.push(this.localePath({ name: 'onboarding.birth-place' }));
        } catch (error) {
          this.isLoading = null;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss">
  .scientist-clock {
    width: rw(106px);
    margin-top: rs(30px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    margin-top: rs(15px);
  }

  .normal-text {
    font-size: rf(16px);
    margin-top: rs(15px);
  }

  .bubbles--custom {
    top: rs(147px);
  }
</style>
